/*** ڸ   ***/

libname klips 'D:\klips\SAS'; * klips  ġ; 
libname data 'D:\klips\SAS\data'; * ο ͼ ġ; 


/** (part1) س⵵  ڸ Ⱦ ͸  (pid  reshape) **/

data ex1; set klips.klips22w;


if jobwave ~= 22 then delete; * 22⵵  ڸ ;
if jobcens = 0 then delete; * ȸ ڷ ; 
if jobclass in (2, 4, 6, 8)  then delete; * 22   ڸ ; 

/** (jobst) **/ 

* j150: (1:,2:ӽ,3:Ͽ,4:/ڿ,5:); 
* j502: (ӱ)(1:ִ,2:,3:߸𸣰ڴ); 
* j503: ();

jobst = j150; 
if j150 =5 then jobst =6; * ް; 
if j150 =4 and (j502 =2 or j503 =0) then jobst =5; * ڿ ( 0ΰ);

if jobst=-1 then jobst =.; 

label 
jobst = "(1:,2:ӽ,3:Ͽ,4:,5:ڿ,6:ް)"
;

keep pid jobwave jobseq jobnum jobnumc jobcens jobtype jobclass mainjob jobst;
 
proc freq; table jobst; run;

proc sort; by pid; run; 

/* ()  pid   jobseq(ڸ) ִ counting ϴ code */  
/*
proc freq; table pid/out=count1(keep=pid count); run; 

data  klips22w1;
merge klips22w1 count1; 
by pid; 
retain count 0; 

proc freq; table count; run; 
*/

data ex1; set ex1;

/*  pid  ڸ orderϴ code */
if pid ~=lag(pid) then n = 1; 
else n+1; 

proc freq; table n; run; * ִ ڸ 4   ; 


/*  ο ؼ      ȯ ( ->  迭) */
proc transpose data=ex1 out=wide11 prefix = jobwave;
	by pid;
	id n; 
	var jobwave;
run; 

proc transpose data=ex1 out=wide21 prefix = jobseq;
	by pid; 
	id n; 
	var jobseq;
run; 

proc transpose data=ex1 out=wide31 prefix = jobnum;
	by pid; 
	id n; 
	var jobnum;
run;

proc transpose data=ex1 out=wide41 prefix = jobnumc;
	by pid; 
	id n; 
	var jobnumc;
run;

proc transpose data=ex1 out=wide51 prefix = jobcens;
	by pid; 
	id n; 
	var jobcens;
run; 

proc transpose data=ex1 out=wide61 prefix = jobtype;
	by pid; 
	id n; 
	var jobtype;
run; 

proc transpose data=ex1 out=wide71 prefix = jobclass;
	by pid; 
	id n; 
	var jobclass;
run; 

proc transpose data=ex1 out=wide81 prefix = mainjob;
	by pid; 
	id n; 
	var mainjob;
run; 

proc transpose data=ex1 out=wide91 prefix = jobst;
	by pid; 
	id n; 
	var jobst;
run; 

data data.example1; 
	merge wide11(drop=_name_) wide21(drop=_name_) wide31(drop=_name_) wide41(drop=_name_) wide51(drop=_name_)  wide61(drop=_name_)  wide71(drop=_name_) wide81(drop=_name_) wide91(drop=_name_);
	by pid; 
	drop _LABEL_;

/*  ִ ڸ 4 ̹Ƿ س⵵ ڸ  ϱ ؼ, 'ִ -jobnum1~4 missing '     */ 
	mjob=4- nmiss(jobnum1, jobnum2, jobnum3, jobnum4); 

label 
mjob = " ڸ " 
;

proc freq; table mjob; run; 


/** (part2)  ֿ ģ (ȸ ڸ ) ڸ   pid ڸ   jobseq Ⱦ ͸  (pid jobseq  reshape) **/


libname klips 'D:\klips\SAS'; * klips  ġ; 
libname data 'D:\klips\SAS\data'; * ο ͼ ġ; 


data ex2; set klips.klips22w;

if jobcens =0 then delete; * ȸ ڷ ; 
if jobwave in (1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11) then delete; * 12-22   ڸ ; 


/** (jobst) **/ 

* j150: (1:,2:ӽ,3:Ͽ,4:/ڿ,5:); 
* j502: (ӱ)(1:ִ,2:,3:߸𸣰ڴ); 
* j503: ();

jobst = j150; 
if j150 =5 then jobst =6; * ް; 
if j150 =4 and (j502 =2 or j503 =0) then jobst =5; * ڿ ( 0ΰ);

if jobst=-1 then jobst =.; 

label 
jobst = "(1:,2:ӽ,3:Ͽ,4:,5:ڿ,6:ް)"
;

/*  pid  ٸ   jobseq(ڸȣ) Ƿ(, pid=101 ڸ jobseq=4 jobseq=4 ڸ ), pid, jobseq  ؾ߸ 'n'    */
/* pid jobseq տ 0 ٿ Ȱ ڸ ְ,   compress code Ȱ ģ  pidseq Ȱ ڸ order 'n'  */  

/* jobseqտ 0ٿ Ȱ ڸ  */ 
digits1 = int(log10(jobseq))+1; * jobseq ڸ (ִڸ=2); 
if digits1=1 then jobseqa=compress('0')||compress(jobseq); * jobseq ڸ 1̸, տ 0 ;
else if digits1=2 then jobseqa=jobseq; * jobseq ڸ 2̸, ״ jobseq  (ִ ڸ); 

/* pidտ 0ٿ Ȱ ڸ  */
digits2 = int(log10(pid))+1; * pid ڸ (ִڸ=8); 
if digits2=3 then pida=compress('00000')||compress(pid); * pid ڸ 3̸, տ 00000 ; 
else if digits2=4 then pida=compress('0000')||compress(pid); * pid ڸ 4̸, տ 0000 ;
else if digits2=5 then pida=compress('000')||compress(pid); * pid ڸ 5̸, տ 000 ;
else if digits2=6 then pida=compress('00')||compress(pid); * pid ڸ 6̸, տ 00 ;
else if digits2=7 then pida=compress('0')||compress(pid); * pid ڸ 7̸, տ 0 ;
else if digits2=8 then pida=pid; * pid ڸ 8̸, ״ pid  (ִ ڸ); 

retain pida jobseqa; * κ  ġ code; 

/* pidseq: pid jobseq   غ */ 
pidseq = compress(pida)||compress(jobseqa); 

keep pid jobwave jobseq jobnum jobnumc jobcens jobtype jobclass mainjob jobst digits1 digits2 jobseqa pida pidseq;   
proc sort; by pidseq; run;

data  ex2; set ex2; 

/*  pid jobseq  ڸ orderϴ code */
if pidseq ~=lag(pidseq) then n = 1; 
else n+1; 
proc freq; table n; run;



/*  ο ؼ      ȯ ( ->  迭) */
proc transpose data=ex2 out=wide12 prefix = jobwave;
	by pid jobseq ;
	id n; 
	var jobwave;
run; 

proc transpose data=ex2 out=wide22 prefix = jobnum;
	by pid jobseq ;
	id n; 
	var jobnum;
run;

proc transpose data=ex2 out=wide32 prefix = jobnumc;
	by pid jobseq ;
	id n; 
	var jobnumc;
run;

proc transpose data=ex2 out=wide42 prefix = jobcens;
	by pid jobseq ;
	id n; 
	var jobcens;
run; 

proc transpose data=ex2 out=wide52 prefix = jobtype;
	by pid jobseq ;
	id n; 
	var jobtype;
run; 

proc transpose data=ex2 out=wide62 prefix = jobclass;
	by pid jobseq ;
	id n; 
	var jobclass;
run; 

proc transpose data=ex2 out=wide72 prefix = mainjob;
	by pid jobseq ;
	id n; 
	var mainjob;
run; 

proc transpose data=ex2 out=wide82 prefix = jobst;
	by pid jobseq ;
	id n; 
	var jobst;
run; 

data data.example2; 
	merge wide12(drop=_name_) wide22(drop=_name_) wide32(drop=_name_) wide42(drop=_name_) wide52(drop=_name_) wide62(drop=_name_) wide72(drop=_name_) wide82(drop=_name_);
	by pid jobseq ;
	drop _LABEL_;
run; 
